 IDENTIFICATION DIVISION.
 PROGRAM-ID. 'P_Winmain'.

* TITLE - Create Fixed Length Sequential File
* DESCRIPTION - Create Fixed Length Sequential File

* Copyright 1998 - Thane Hubbell (redsky@ibm.net)
* Portions Copyright Flexus International (http://www.flexus.com)
* E-mail me with comments or questions (redsky@ibm.net).

 ENVIRONMENT DIVISION.
 INPUT-OUTPUT SECTION.
 FILE-CONTROL.
     SELECT INPUT-FILE ASSIGN VARYING INPUT-FILE-NAME
	    FILE STATUS IN-STAT.
     SELECT OUTPUT-FILE ASSIGN VARYING OUTPUT-FILE-NAME
	    FILE STATUS OUT-STAT.
 DATA DIVISION.
 FILE SECTION.
 FD  INPUT-FILE.
 01  IN-REC PIC X.
 FD  OUTPUT-FILE.
 01  OUT-REC PIC X.
 WORKING-STORAGE SECTION.

 COPY "sp2.cpy".

 COPY "conv.cpy".
 01  IN-STAT PIC XX VALUE ZEROS.
     88  IN-SUCCESS VALUE "00".
     88  IN-END  VALUE "10".
     88  IN-MISSING VALUE "35".
 01  OUT-STAT PIC XX VALUE ZEROS.
     88  OUT-SUCCESS VALUE "00".
     88  OUT-MISSING VALUE "35".
 01  DONE-FLAG PIC X VALUE SPACES.
     88  ALL-DONE VALUE "Y".
 01  ERROR-FLAG PIC X VALUE SPACES.
     88  NO-ERROR VALUE SPACES.
     88  BAD-IN VALUE "1".
     88  OUT-EXISTS VALUE "2".
     88  BAD-RECL VALUE "3".
 01  BYTES-READ 		PIC 9(5) VALUE ZEROS.
 01  LAST-BYTE			PIC X VALUE LOW-VALUES.
 01  INPUT-FILE-NAME		PIC X(15).
 01  OUTPUT-FILE-NAME		PIC X(15).
 LINKAGE SECTION.
 01  INSTANCE			 PIC 9(4) BINARY.
 01  PREV-INSTANCE		 PIC 9(4) BINARY.
 01  CMD-LINE			 PIC X(120).
 01  CMD-SHOW			 PIC 9(4) BINARY.

 PROCEDURE DIVISION USING
     BY CONTENT INSTANCE PREV-INSTANCE
     BY REFERENCE CMD-LINE
     BY CONTENT CMD-SHOW.

 MAINLINE.
******************
* MAINLINE LOGIC *
******************
     PERFORM PROC-OPEN-FILE
     MOVE LOW-VALUES TO conv-DATA
     MOVE "conv" TO conv-NEXT-PANEL
     MOVE "y" TO conv-NEW-WINDOW
     MOVE LOW-VALUES TO conv-FIELDS
     MOVE LOW-VALUES TO conv-COLRS
     MOVE LOW-VALUES TO conv-TYPES
     SET CONV-CRLF-YES TO TRUE
     MOVE 80 TO CONV-RECL
     PERFORM PROC-CON-conv UNTIL ALL-DONE
     PERFORM PROC-CLOSE-WINDOW
     PERFORM PROC-CLOSE-FILE
     PERFORM PROC-END-SESSION
     STOP RUN
     .
 PROC-OPEN-FILE.
*****************
* OPEN SP2 FILE *
*****************
     MOVE LOW-VALUES TO SP2-FI-DATA
     MOVE "CONV.PAN" TO SP2-FI-NAME
     CALL "SP2" USING SP2-OPEN-FILE SP2-FILE-DEF
     .
 PROC-CON-conv.
******************
* CONVERSE PANEL *
******************
     CALL "SP2" USING SP2-CONVERSE-PANEL conv-CONVERSE-DATA
     MOVE LOW-VALUE TO conv-NEW-WINDOW
     IF NOT CONV-KEY = SP2-KEY-CLOSE
	PERFORM SET-MOUSE-WAIT
	PERFORM VALIDATE-AND-PROCESS
     ELSE
	SET ALL-DONE TO TRUE
     END-IF
     .
 VALIDATE-AND-PROCESS.
     SET NO-ERROR TO TRUE
     STRING CONV-INPUT-FILE DELIMITED BY SPACE
            "[B]" DELIMITED BY SIZE
	    INTO INPUT-FILE-NAME
     END-STRING
     STRING CONV-OUTPUT-FILE DELIMITED BY SPACE
            "[B]" DELIMITED BY SIZE
	    INTO OUTPUT-FILE-NAME
     END-STRING
     OPEN INPUT INPUT-FILE
     OPEN INPUT OUTPUT-FILE
     IF OUT-SUCCESS
	 SET OUT-EXISTS TO TRUE
	 MOVE CONV-OUTPUT-FILE-I TO CONV-NEXT-FLD-ID
     END-IF
     IF IN-MISSING
	 SET BAD-IN TO TRUE
	 MOVE CONV-INPUT-FILE-I TO CONV-NEXT-FLD-ID
     END-IF
     IF CONV-RECL < 1
	 SET BAD-RECL TO TRUE
	 MOVE CONV-RECL-I TO CONV-NEXT-FLD-ID
     END-IF
     CLOSE INPUT-FILE OUTPUT-FILE
     IF NO-ERROR
	PERFORM DO-PROCESS
     ELSE
	EVALUATE TRUE
	  WHEN BAD-IN
	    MOVE LOW-VALUES TO SP2-MS-DATA
            MOVE "b" TO SP2-MS-ICON
            MOVE "Input Missing" TO SP2-MS-TITLE
            STRING "Input File Missing"
		DELIMITED BY SIZE
		INTO SP2-MS-TEXT
            MOVE "o" TO SP2-MS-BUTTON
            MOVE "n" TO SP2-MS-CANCEL
	    MOVE 1 TO SP2-MS-LINE-CNT
	    PERFORM SET-MOUSE-NORMAL
            CALL "SP2" USING SP2-DISPLAY-MESSAGE SP2-MESSAGE-DATA
	  WHEN OUT-EXISTS
	    MOVE LOW-VALUES TO SP2-MS-DATA
            MOVE "b" TO SP2-MS-ICON
            MOVE "Output Exists" TO SP2-MS-TITLE
            STRING "Output File Exists, Overwrite?"
		DELIMITED BY SIZE
		INTO SP2-MS-TEXT
            MOVE "y" TO SP2-MS-BUTTON
            MOVE "n" TO SP2-MS-CANCEL
	    MOVE 1 TO SP2-MS-LINE-CNT
	    PERFORM SET-MOUSE-NORMAL
            CALL "SP2" USING SP2-DISPLAY-MESSAGE SP2-MESSAGE-DATA
            IF SP2-MS-REPLY = "y"
	       PERFORM DO-PROCESS
	    END-IF
	 WHEN BAD-RECL
	    MOVE LOW-VALUES TO SP2-MS-DATA
            MOVE "b" TO SP2-MS-ICON
            MOVE "Bad Record Length" TO SP2-MS-TITLE
            STRING "Record Length must be at least 1"
		DELIMITED BY SIZE
		INTO SP2-MS-TEXT
            MOVE "o" TO SP2-MS-BUTTON
            MOVE "n" TO SP2-MS-CANCEL
	    MOVE 1 TO SP2-MS-LINE-CNT
	    PERFORM SET-MOUSE-NORMAL
            CALL "SP2" USING SP2-DISPLAY-MESSAGE SP2-MESSAGE-DATA
	END-EVALUATE
     END-IF
     .
 DO-PROCESS.
     OPEN INPUT INPUT-FILE
	  OUTPUT OUTPUT-FILE
     PERFORM UNTIL NOT IN-SUCCESS OR
		   NOT OUT-SUCCESS
       READ INPUT-FILE
* correct problem with extra blank record 11/30/98
       IF IN-END AND BYTES-READ > ZERO
	  PERFORM FILL-DATA-END
       END-IF
       IF IN-SUCCESS
	  EVALUATE IN-REC ALSO CONV-CR
            WHEN X"0D" ALSO "C"
	      PERFORM FILL-DATA-END
            WHEN X"0A" ALSO "L"
	      PERFORM FILL-DATA-END
            WHEN X"0D" ALSO "B"
	      MOVE IN-REC TO LAST-BYTE
            WHEN X"0A" ALSO "B"
              IF LAST-BYTE = X"0D"
		 PERFORM FILL-DATA-END
	      ELSE
		 WRITE OUT-REC FROM LAST-BYTE
		 WRITE OUT-REC FROM IN-REC
		 MOVE IN-REC TO LAST-BYTE
		 ADD 2 TO BYTES-READ
	      END-IF
* added this when 11/26/98 to correct a problem with
* stray X"0d" characters being dropped.
            WHEN ANY ALSO "B"
              IF LAST-BYTE = X"0D"
		 WRITE OUT-REC FROM LAST-BYTE
		 WRITE OUT-REC FROM IN-REC
		 MOVE IN-REC TO LAST-BYTE
* was not adding 2!
		 ADD 2 TO BYTES-READ
	      ELSE
		 WRITE OUT-REC FROM IN-REC
* was not adding 1 to bytes read - 11/30/98
		 ADD 1 TO BYTES-READ
		 MOVE IN-REC TO LAST-BYTE
	      END-IF
	    WHEN OTHER
	      WRITE OUT-REC FROM IN-REC
	      MOVE OUT-REC TO LAST-BYTE
	      ADD 1 TO BYTES-READ
	  END-EVALUATE
       END-IF
     END-PERFORM
     IF IN-END AND OUT-SUCCESS
	    MOVE LOW-VALUES TO SP2-MS-DATA
            MOVE "i" TO SP2-MS-ICON
            MOVE "Success" TO SP2-MS-TITLE
            STRING "Process Successful!"
		DELIMITED BY SIZE
		INTO SP2-MS-TEXT
            MOVE "o" TO SP2-MS-BUTTON
            MOVE "n" TO SP2-MS-CANCEL
	    MOVE 1 TO SP2-MS-LINE-CNT
	    PERFORM SET-MOUSE-NORMAL
            CALL "SP2" USING SP2-DISPLAY-MESSAGE SP2-MESSAGE-DATA
	    SET ALL-DONE TO TRUE
     ELSE
	    MOVE LOW-VALUES TO SP2-MS-DATA
            MOVE "b" TO SP2-MS-ICON
            MOVE "Failure" TO SP2-MS-TITLE
            STRING "Process Failed!"
                X"0D0A"
                "In Status " IN-STAT
                X"0D0A"
                "Out Status " OUT-STAT
		DELIMITED BY SIZE
		INTO SP2-MS-TEXT
            MOVE "o" TO SP2-MS-BUTTON
            MOVE "n" TO SP2-MS-CANCEL
	    MOVE 1 TO SP2-MS-LINE-CNT
	    PERFORM SET-MOUSE-NORMAL
            CALL "SP2" USING SP2-DISPLAY-MESSAGE SP2-MESSAGE-DATA
	    SET ALL-DONE TO TRUE
     END-IF
     CLOSE INPUT-FILE OUTPUT-FILE
     .
 FILL-DATA-END.
     IF BYTES-READ > CONV-RECL
	    MOVE LOW-VALUES TO SP2-MS-DATA
            MOVE "b" TO SP2-MS-ICON
            MOVE "Failure" TO SP2-MS-TITLE
            STRING "Record Exceeds max length!"
		DELIMITED BY SIZE
		INTO SP2-MS-TEXT
            MOVE "o" TO SP2-MS-BUTTON
            MOVE "n" TO SP2-MS-CANCEL
	    MOVE 1 TO SP2-MS-LINE-CNT
	    PERFORM SET-MOUSE-NORMAL
            CALL "SP2" USING SP2-DISPLAY-MESSAGE SP2-MESSAGE-DATA
	    SET ALL-DONE TO TRUE
            MOVE "99" TO IN-STAT OUT-STAT
     ELSE
       PERFORM UNTIL BYTES-READ = CONV-RECL
	    ADD 1 TO BYTES-READ
            WRITE OUT-REC FROM " "
       END-PERFORM
       EVALUATE TRUE
	   WHEN CONV-CR-YES
                WRITE OUT-REC FROM X"0D"
                MOVE X"0D" TO LAST-BYTE
	   WHEN CONV-CRLF-YES
                WRITE OUT-REC FROM X"0D"
                WRITE OUT-REC FROM X"0A"
                MOVE X"0A" TO LAST-BYTE
	   WHEN CONV-LF-YES
                WRITE OUT-REC FROM X"0A"
                MOVE X"0A" TO LAST-BYTE
       END-EVALUATE
       MOVE ZEROS TO BYTES-READ
     END-IF
     .
 PROC-CLOSE-WINDOW.
************************
* CLOSE CURRENT WINDOW *
************************
     CALL "SP2" USING SP2-CLOSE-WINDOW SP2-NULL-PARM
     .
 PROC-CLOSE-FILE.
**********************
* CLOSE CURRENT FILE *
**********************
     CALL "SP2" USING SP2-CLOSE-FILE SP2-NULL-PARM
     .
 PROC-END-SESSION.
*******************
* END SP2 SESSION *
*******************
     CALL "SP2" USING SP2-END-SESSION SP2-NULL-PARM
     .
 SET-MOUSE-WAIT.
     MOVE 6 TO SP2-NP-RET-CODE
     CALL "SP2" USING SP2-SET-MOUSE-SHAPE SP2-NULL-PARM
     .
 SET-MOUSE-NORMAL.
     MOVE 0 TO SP2-NP-RET-CODE
     CALL "SP2" USING SP2-SET-MOUSE-SHAPE SP2-NULL-PARM
     .
